/**************************************************************************
//
//  Copyright (c) 2006-2007 Sony Corporation. All Rights Reserved.
//
//  File Name: setupinterface.h
//  Description: setup interface header
//
//   Redistribution and use in source and binary forms, with or without
//   modification, are permitted provided that the following conditions
//   are met:
//
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in
//       the documentation and/or other materials provided with the
//       distribution.
//     * Neither the name of Sony Corporation nor the names of its
//       contributors may be used to endorse or promote products derived
//       from this software without specific prior written permission.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
//   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**************************************************************************/

#ifndef SETUPINTERFACE_H
#define SETUPINTERFACE_H

#include "ui_setupinterface.h"
#include "pagetemplate.h"

#include <QRegExpValidator>

#ifdef CONFIG_NATIVE_WINDOWS
#include <QComboBox>
#include "win_if_list.h"
#endif // CONFIG_NATIVE_WINDOWS

class TestbedSta;


class SetupInterface:
public PageTemplate, public Ui::SetupInterface
{
Q_OBJECT
public:
	SetupInterface(QWidget *wizard, QWidget *parent = 0, Qt::WindowFlags f = 0);
	~SetupInterface();

	const char *getWirelessInterface();
	const char *getWiredInterface();

public:
	bool pre_back();
	bool pre_next();
	bool post_next();
	void cancel();

private:
	TestbedSta *wiz;

	QValidator *validator;
	QValidator *validator2;
	QValidator *validator3;
	QValidator *validator4;
	bool checkInputs();

	bool end();

#ifdef CONFIG_NATIVE_WINDOWS
	win_if_t *if_list;
	QComboBox *cmbWInterface;

	void displayWInterfaceList();
#endif // CONFIG_NATIVE_WINDOWS

private slots:
	void enabledDhcp();
	void enabledDhcp2();
#ifdef CONFIG_NATIVE_WINDOWS
	void selectWInterface(int index);
#endif // CONFIG_NATIVE_WINDOWS

};

#endif // SETUPINTERFACE_H
